import {
  select, 
  json, 
  geoPath,
  set,
  geoCentroid,
  geoAlbersUsa,
  zoom,
  event
} from 'd3';

import { feature, merge } from 'topojson';
import { loadAndProcessData } from './loadAndProcessData';

const svg = select('svg');
let data;
const width = +svg.attr('width');
const height = +svg.attr('height');

//zoom!
const g = svg.append('g');
svg.call(zoom().on('zoom', ()=>{
  g.attr('transform', event.transform)
}));


const USmap = geoAlbersUsa();
const pathGenerator = map => geoPath().projection(map);
 
loadAndProcessData().then(data => {
  
  
  render(data);
});


const render = (data) => {
//logic for regions
  //svg.append("path")
   //.datum(merge(data, data.objects.states.geometries.filter(function(d) { return NorthEast.has(d.id); })))
   //.attr("class", "NorthEast")
   //.attr("d", path);
  //svg.append("path")
   //.datum(merge(data, data.objects.states.geometries.filter(function(d) { return MidWest.has(d.id); })))
   //.attr("class", "MidWest")
  //.attr("d", path);
 //svg.append("path")
   //.datum(merge(data, data.objects.states.geometries.filter(function(d) { return South.has(d.id); })))
   //.attr("class", "South")
  //.attr("d", path);
 //svg.append("path")
   //.datum(merge(data, data.objects.states.geometries.filter(function(d) { return West.has(d.id); })))
  //.attr("class", "West")
 //.attr("d", path)
  

    g.selectAll('path')
      .data(data.features)
      .enter().append('path')
  		.attr('class', 'states')
      .attr('d', pathGenerator(USmap)) 
  	  .append('title')
  		.text(d => d);
  
    data.features.pop() //not sure why last 2 arnt working
    data.features.pop() //not sure why last 2 arnt working
    g.append("g")
      .attr("class","circle")
      .selectAll("circle")
      .data(data.features)
      .enter().append("circle")
      .attr('cx', d => USmap(geoCentroid(d))[0])
      .attr('cy', d => USmap(geoCentroid(d))[1])
      .attr('r',5)
      .attr('fill','red')

};     






